package win32neshto.j2mesafemod;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.TextField;

public class CreateEntryForm extends EntryDetailForm implements SetTextInterface {
  TextField label;
  TextField body;
  Command saveCommand = new Command(Str.SAVE, Command.SCREEN, 1);
  Command editCommand = new Command(Str.EDIT_WITH_TEXTBOX, Command.SCREEN, 5);  
  Command generateCommand = new Command(Str.GENERATE_PASSWORD, Command.SCREEN, 10);  
  
  public CreateEntryForm(J2MESafe app) {
    super(app, Str.NEW_ENTRY);
    label = new TextField(Str.LABEL, "", Consts.MAX_LABEL_LENGTH, TextField.NON_PREDICTIVE);
    body = new TextField(Str.BODY, "", Consts.MAX_TEXT_LENGTH, TextField.NON_PREDICTIVE);
    append(label);
    append(body);

    addCommand(saveCommand);
    addCommand(editCommand);
    addCommand(generateCommand);
  }


  public void commandAction(Command c, Displayable d) {
    if (c == saveCommand) {
      String l = label.getString();
      if(l.length()==0) {
          return;
      }
      String b = body.getString();
      app.entryList.createEntry(l, b);
      app.entryList.sort();
      app.getDisplay().setCurrent(app.entryList);
    } else if(c==generateCommand) {
        GeneratePasswordOptionsForm f = new GeneratePasswordOptionsForm(app, this);
        app.getDisplay().setCurrent(f);  
    } else if(c==editCommand) {
        String caption = label.getString();
        if(caption.length()==0) {
            caption = Str.NEW_ENTRY;
        }
        EditTextBox box = new EditTextBox(app, caption, body.getString(), this);
        app.getDisplay().setCurrent(box);        
    } else {
      super.commandAction(c, d);
    }
  }

    public Displayable getDisplayable() {
        return this;
    }

    public void setText(String text) {
        body.setString(text);
    }
  
}
