package win32neshto.j2mesafemod;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.TextField;

public class AskPasswordForm extends LoginForm {
  TextField textField;
  Command enterCommand = new Command(Str.LOGIN, Command.SCREEN, 1);
  Command deleteCommand = new Command(Str.NEW_PASSCODE, Command.SCREEN, 1);

  public AskPasswordForm(J2MESafe app) {
    super(app, Str.ENTER_PASSCODE);
    textField = new TextField(Str.PASSCODE, "", 15, TextField.NUMERIC | TextField.PASSWORD);
    append(textField);
    addCommand(enterCommand);
    addCommand(deleteCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == deleteCommand)
      app.getDisplay().setCurrent(app.deletePasswordForm);
    else if (c == enterCommand) {
      String code = textField.getString();
      if (!app.passwordMgr.match(code)) {
        textField.setString("");
        Alert alert = new Alert(Str.ERROR, Str.INVALID_PASSCODE, null, null);
        alert.setTimeout(Alert.FOREVER);
        alert.addCommand(new Command(Str.OK, Command.OK, 1));
        app.getDisplay().setCurrent(alert, this);
      } else {
        app.cryptMgr.initialize(code);
        app.entryMgr.initialize();
        app.entryList.sort();
        app.getDisplay().setCurrent(app.entryList);
      }
    } else
      super.commandAction(c, d);
  }
}