package win32neshto.j2mesafemod;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.TextField;

public class ChangeEntryForm extends EntryDetailForm implements SetTextInterface {
  TextField label;
  TextField body;
  Entry entry;
  Command saveCommand = new Command(Str.SAVE, Command.SCREEN, 1);
  Command editCommand = new Command(Str.EDIT_WITH_TEXTBOX, Command.SCREEN, 5);
  Command generateCommand = new Command(Str.GENERATE_PASSWORD, Command.SCREEN, 10);
  
  public ChangeEntryForm(J2MESafe app, Entry entry) {
    super(app, Str.CHANGE_ENTRY);
    this.entry = entry;
    label = new TextField(Str.LABEL, entry.getLabel(), Consts.MAX_LABEL_LENGTH, TextField.NON_PREDICTIVE);
    body = new TextField(Str.BODY, entry.getBody(), Consts.MAX_TEXT_LENGTH, TextField.NON_PREDICTIVE);
    append(label);
    append(body);
    addCommand(saveCommand);
    addCommand(editCommand);
    addCommand(generateCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == saveCommand) {
        if(label.getString().length()==0) {
            return;
        }
      entry.setLabel(label.getString());
      entry.setBody(body.getString());
      app.entryList.changeEntry(entry);
      app.entryList.sort();
      app.getDisplay().setCurrent(app.entryList);
    } else if(c==generateCommand) {
        GeneratePasswordOptionsForm f = new GeneratePasswordOptionsForm(app, this);
        app.getDisplay().setCurrent(f);
    } else if(c==editCommand) {
        EditTextBox box = new EditTextBox(app, label.getString(), body.getString(), this);
        app.getDisplay().setCurrent(box);
    } else {
      super.commandAction(c, d);
    }
  }

    public Displayable getDisplayable() {
        return this;
    }

    public void setText(String text) {
        body.setString(text);
    }
}