package win32neshto.j2mesafemod;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.midlet.MIDlet;
/**
 * An example MIDlet shows the values of the system properties. Refer to the
 * startApp, pauseApp, and destroyApp methods so see how it handles each
 * requested transition.
 */
public class J2MESafe extends MIDlet implements CommandListener {
  Display display;
  PasswordMgr passwordMgr;
  
  Command exitCommand = new Command(Str.EXIT, Command.EXIT, 1);
  
  InitialPasswordForm initialPasswordForm;
  AskPasswordForm askPasswordForm;
  DeletePasswordForm deletePasswordForm;
  CryptMgr cryptMgr;
  EntryMgr entryMgr;
  EntryList entryList;
  
  boolean paused = false;
  
  /*
   * Construct a new PropExample.
   */
  public J2MESafe() {
    display = Display.getDisplay(this);
  }

  /**
   * Start application (initial or paused)
   */
  public void startApp() {
      if(paused) {
          paused = false;
          return;
      }
    passwordMgr = new PasswordMgr();
    cryptMgr = new TwofishCryptMgr();
    entryMgr = new EntryMgr(cryptMgr);
    
    initialPasswordForm = new InitialPasswordForm(this);
    askPasswordForm = new AskPasswordForm(this);
    deletePasswordForm = new DeletePasswordForm(this);
    entryList = new EntryList(this);
    
    Displayable current = initialPasswordForm;
    if (passwordMgr.isInitialized())
      current = askPasswordForm;
    display.setCurrent(current);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == exitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
  }

  /**
   * Time to pause, free any space we don't need right now.
   */
  public void pauseApp() {
    display.setCurrent(null);
    paused = true;
  }

  /**
   * Destroy must cleanup everything.
   */
  public void destroyApp(boolean unconditional) {
  }
  

  /**
   * @return Returns the display.
   */
  public Display getDisplay() {
    return display;
  }
}